---
title: Python
description: Tips and useful libraries for python developers
image: "img/python.png"
categories:
  - programming
tags:
  - python
  - programming
---

## Interesting libraries

### [TQDM](https://github.com/tqdm/tqdm)


From tqdm's github repository:

> tqdm means "progress" in Arabic (taqadum, تقدّم) and an abbreviation for "I love you so much" in Spanish (te quiero demasiado).


 ![TQDM in action](https://raw.githubusercontent.com/tqdm/tqdm/master/images/tqdm.gif)

## Tools

### [uv](https://github.com/astral-sh/uv)

🚀 A single tool to replace pip, pip-tools, pipx, poetry, pyenv, twine, virtualenv, and more.
⚡️ 10-100x faster than pip.
* Provides comprehensive project management, with a universal lockfile.
* Runs scripts, with support for inline dependency metadata.
* Installs and manages Python versions.
* Runs and installs tools published as Python packages.
* Includes a pip-compatible interface for a performance boost with a familiar CLI.
* Supports Cargo-style workspaces for scalable projects.
* Disk-space efficient, with a global cache for dependency deduplication.
* Installable without Rust or Python via curl or pip.
* Supports macOS, Linux, and Windows.
